unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, ExtCtrls, jpeg;
type
  TForm1 = class(TForm)
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    Panel1: TPanel;
    Image1: TImage;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    Button3: TButton;
    GroupBox3: TGroupBox;
    ListBox2: TListBox;
    GroupBox4: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button4: TButton;
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketLookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   ServerSocket.Socket.Connections[0].SendText(Socket.ReceiveText);
end;

procedure TForm1.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
ClientSocket.Socket.SendText(Socket.ReceiveText);
ListBox2.Items.Add('Server accepting user read...');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
ServerSocket.Active:=False;;
ClientSocket.Active:=False;;
ServerSocket.Close;
ClientSocket.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
ClientSocket.Host:='elte.irc.hu';
Listbox1.Items.Add('Server.: elte.irc.hu:6667');
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
ClientSocket.Host:='extra.irc.hu';
Listbox1.Items.Add('Server.: extra.irc.hu:6667');
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
ClientSocket.Host:='sote.irc.hu';
Listbox1.Items.Add('Server.: sote.irc.hu:6667');
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
ClientSocket.Host:='hub.irc.hu';
Listbox1.Items.Add('Server.: hub.irc.hu:6667');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
ServerSocket.Open;
ClientSocket.Open;
Button1.Visible:=True;
Button2.Visible:=False;
GroupBox1.Visible:=False;
GroupBox2.Visible:=False;
GroupBox3.Visible:=True;
ListBox1.Visible:=False;
ListBox2.Visible:=True;
GroupBox4.Visible:=False;
Label1.Visible:=True;
Label2.Visible:=True;
Label3.Visible:=True;
Label4.Visible:=True;
Image1.Visible:=True;
Bevel1.Visible:=True;
Listbox2.Items.Add('BNC Started!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Listbox1.Items.Add('Loading HaRkOn WinBNC v0.0.7...');
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
Listbox1.Items.Insert(2,'Everything sucesfully done!');
Form1.Refresh;
end;

procedure TForm1.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Server connection accpeted!');
end;

procedure TForm1.ClientSocketConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Server loading on port 6667...');
end;

procedure TForm1.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
ClientSocket.Active := False;
Listbox2.Items.Add('Server disconnected!');
end;

procedure TForm1.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Listbox2.Items.Add('Server disconnected by an error...');
end;

procedure TForm1.ClientSocketLookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Server waiting clients to connect...');
end;

procedure TForm1.ClientSocketWrite(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Server write!');
end;

procedure TForm1.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Client connecting...');
end;

procedure TForm1.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Listbox2.Items.Add('Client disconnected...');
end;

procedure TForm1.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Listbox2.Items.Add('Client disconnected by an error!');
end;

procedure TForm1.ServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
ClientSocket.Active := True;
Listbox2.Items.Add('Server accepted the client!');
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
ServerSocket.Close;
ClientSocket.Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Label1.Visible:=False;
Label2.Visible:=False;
Label3.Visible:=False;
Label4.Visible:=False;
Image1.Visible:=False;
Bevel1.Visible:=False;
GroupBox1.Visible:=True;
GroupBox4.Visible:=True;
Button3.Visible:=False;
Button2.Visible:=True;
Listbox1.Items.Insert(3,'Default server.: irc.elte.hu:6667');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
ServerSocket.Active:=False;
ClientSocket.Active:=False;
ClientSocket.Host:=Edit1.Text;
ClientSocket.Port:=6667;
GroupBox1.Enabled:=False;
Listbox1.Items.Insert(4,'New server and port loaded...');
ServerSocket.Active:=True;
ClientSocket.Active:=True;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
Listbox1.Items.Insert(1,'Server port loading...');
end;

end.
