#define GLUT_DISABLE_ATEXIT_HACK 
#include <windows.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

float x=0;
float y=0;
float xm=0.01;
float ym=0.01;

void SceneIdle(void)
{
	if ( (x>=.5)||(x<=-.5) )
		{
			xm=-xm;
		}
	if ( (y>=.4)||(y<=-.4) )
		{
			ym=-ym;
		}
	x=x+xm;
	y=y+ym;
	glutPostRedisplay();
}

void RenderScene(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f );
	glColor4f(1.0f, 0.8f, 0.8f, 1.0f);
	glBegin(GL_QUADS);
		glVertex3f(-0.5f, -0.5f, -0.1f);
		glVertex3f(-0.5f,  0.5f, -0.1f);
		glVertex3f( 0.5f,  0.5f, -0.1f);
		glVertex3f( 0.5f, -0.5f, -0.1f);
	glEnd();
	glBegin(GL_QUADS);
	    glColor4f(1.0f, 0.0f, 0.0f, 0.5f);
		glVertex3f(-0.5f+x, -0.5f+y, 0.0f);
		glColor4f(0.0f, 1.0f, 0.0f, 0.5f);
		glVertex3f(-0.5f+x,  0.5f+y, 0.0f);
		glColor4f(0.0f, 0.0f, 1.0f, 0.5f);
		glVertex3f( 0.5f+x,  0.5f+y, 0.0f);
		glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
		glVertex3f( 0.5f+x, -0.5f+y, 0.0f);
	glEnd();
	glutSwapBuffers();
}

int main(int argc, char* argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutCreateWindow("Pelda06");
	glutDisplayFunc(RenderScene);
	glutIdleFunc(SceneIdle);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glutMainLoop();
	return 0;
}
