unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NMUDP, StrUtils, WinSock, ExtCtrls, Buttons;
  //a WinSock-ot tettem hozz, ez kell az API hvshoz (Timer1.Timer eljrs)
  //Ne felejtsk el a form.formclose eljrst sem, ez akkor is lefut, ha az
  //ablak jobb fels sarkn lv X-re kattintunk!
const
  mag=360;  //a form magassgt adja meg
type
  TForm1 = class(TForm)
    udp: TNMUDP;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    ListBox3: TListBox;
    Edit6: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label6: TLabel;
    Memo3: TMemo;
    Label8: TLabel;
    Timer1: TTimer;
    button6: TSpeedButton;
    button1: TSpeedButton;
    Button2: TSpeedButton;
    button3: TSpeedButton;
    button4: TSpeedButton;
    Button5: TSpeedButton;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure udpBufferInvalid(var handled: Boolean;
      var Buff: array of Char; var length: Integer);
    procedure udpDataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure udpInvalidHost(var handled: Boolean);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure Memo3Change(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure ListBox3KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    procedure kuldd(ip, port, msg : string);
    { Public declarations }
  end;

var
  Form1: TForm1;
  magassag : integer;    //a form magasst trolja
  selfname : string;     //sajt nevnk (HostName)
  sonar : string;        //a szonr IP cmet tartalmazza
  villog : byte;         //a napl 6-szor villog, ennek rtke ez a vltoz

implementation

{$R *.dfm}

procedure TForm1.kuldd(ip, port, msg : String); //a kld eljrs
var
  i : byte;                                     //a ciklusvltoz s a
  ast : array[1..255] of char;                  //karaktertmb, ebbl kett van:
  //egy az adatok rkezsnl s egy itt. Lehetne egy globlis is.
begin
  udp.RemoteHost:=ip;             //belltjuk a cmzettet
  udp.RemotePort:=strtoint(port); //egy portot hasznlok a kimen s bejv
  msg:='#0'+selfname+msg;         //protokoll formra hozzuk az zenetet
  //igazbl itt csak a nevet ragasztjuk hozz, mert a parancs s az zenet
  //mr ltrejtt, amikor rkattintunk a Kld! gombra.
  if msg<>'' then                 //ha res string-et kapunk nem kldjk el.
  begin
    for i:=1 to length(msg) do    //feltltjk a tmbt...
      ast[i]:=msg[i];
    udp.SendBuffer(ast, i-1);     //...s elkldjk
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  villog:=0;    //a villog inicializlsa
  {formcreate}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;        //"Kilp" gombra kilpnk
end;

procedure TForm1.Button1Click(Sender: TObject); //Kld!
var
  i, j : Integer;          //ciklusvltozk
  kinek : string;          //ebbe bogozzuk ki, ki van kijellve a listboxban
  ast : array[1..255] of char; //a direkt kldshez
begin
  selfname:=edit4.Text;    //sajt nv vltoz feltltse, ksbb kell
  if (edit6.Text='') then  //ha a direkt szvegdoboz res...
  begin
    if (edit3.Text<>'') and (listbox3.SelCount<>0) then //...a szveg nem
    //res string s ki van vlasztva valaki a listbl,
    begin
      for i:=1 to listbox3.items.count do  //akkor 1-tl listbox3 elemeinek szmig
        if listbox3.Selected[i-1]=true then //megnzzk, kivlasztott-e
        begin                               //ha igen, akkor
          for j:=length(listbox3.Items.Strings[i-1])-1 downto 1 do
            if listbox3.Items.Strings[i-1][j]<>'(' then  //a zrjeles rszt
              kinek:=kinek+listbox3.Items.Strings[i-1][j]//kiolvassuk (IP cm)
            else
              break;
           //s zenetet kldnk neki, msg paranccsal
           kuldd(ReverseString(kinek), edit2.Text, '#msg#'+edit3.text);
           label8.Visible:=true;
           //majd hozzadjuk az elkldtt zenetek listjhoz
           memo1.Lines.Add(edit3.Text+' (to '+listbox3.Items[i-1]+')');
           kinek:='';
        end;
      edit3.Text:=''; //trljk a szvegdobozt
    end;
  end
  else
  if edit1.Text<>'' then //ha edit6-ba van rva, s edit1-ben van cm, akkor
  begin                  //direktben kldnk valamit
    udp.RemoteHost:=edit1.Text;    //szoksos inicializls
    udp.RemotePort:=strtoint(edit2.Text);
//    udp.LocalPort:=udp.RemotePort;
    for i:=1 to length(edit6.Text) do   //buffer feltltse
      ast[i]:=edit6.text[i];
    udp.SendBuffer(ast, i-1);           //klds
    //s hozzadjuk a kldtt zenetek listjhoz, - DIREKT kiegsztssel
    memo1.Lines.Add(edit6.Text+' (to '+edit1.Text+' - DIREKT)');
    edit6.Text:='';
  end;
end;

procedure TForm1.udpBufferInvalid(var handled: Boolean;
  var Buff: array of Char; var length: Integer);
begin
  showmessage('Buffer Invalid!');
end;

procedure TForm1.udpDataReceived(Sender: TComponent; NumberBytes: Integer;
  FromIP: String; Port: Integer);  //adatrkezs!
var
  ast2 : array[1..255] of char;  //az rkez adatokhoz kell
  st2 : string;                  //a puffer stringg alaktshoz
  i : byte;                      //ciklusvltoz
  j : integer;                   //ciklusvltoz
  nick, comm, msg : string;      //nv, parancs, s zenet kiolvasshoz
  logged : boolean;
begin
  nick:='';                      //inicializls
  comm:='';
  msg:='';
  st2:='';
  udp.ReadBuffer(ast2, j);       //a puffer kiolvassa, j a pufferben tall-
  if j>0 then                    //hat adatok szma, ha nagyobb mint 0, akkor
  begin
    for i:=1 to j do             //stringbe tesszk
      if ast2[i]<>'' then
        st2:=st2+ast2[i];
    if st2[1]+st2[2]='#0' then   //ha #0-val kezddik, akkor
    begin
      for i:=3 to length(st2) do //sztszedjk
        if st2[i]='#' then
          break
        else
          nick:=nick+st2[i];     //nvre,
      for j:=i+1 to length(st2) do
        if st2[j]='#' then
          break
        else
          comm:=comm+st2[j];     //parancsra,
      for i:=j+1 to length(st2) do
         msg:=msg+st2[i];        //s zenetre
      if nick='' then
        nick:='Ismeretlen';      //ha nvknt nincs megadva semmi, akkor Ismeretlen
    end;

    //parancsok feldolgozsa

    if comm='ok' then            //ok
    begin                        //a cmzett megkapta az zenetet
      label8.Caption:='Megrkezett: '+nick+' ('+FromIP+')';
    end
    else
    if comm='login' then     //login
    begin
      if nick<>selfname then //ha nem magunktl kapunk logint (mindenkiben mi is benne vagyunk!)
      begin                  //vgignzzk a listnkat,
        for i:=1 to listbox3.Items.Count do
          if listbox3.Items.Strings[i-1]=nick+' ('+FromIP+')' then
          begin
            logged:=true;
            break;
          end
          else
            logged:=false;      //s ha mg nincs meg az adott emberke
        if logged=false then    //akkor hozzadjuk
        begin
          listbox3.Items.add(nick+' ('+FromIP+')');
                                //majd berjuk a naplba is,
          memo3.Lines.Add('rkezett: '+nick+' ('+FromIP+')');
        end;
        kuldd(FromIP, edit2.Text, '#logged#'); //s visszajelznk neki, hogy
                                               //mi mr bent vagyunk
      end;
    end
    else
    if comm='logged' then     //ha logged parancsot kapunk
    begin
      if nick<>selfname then  //megnzzk nem magunktl kaptuk-e (klnben vgtelen ciklus!)
      begin                   //vgignzzk a listnkat
        for i:=1 to listbox3.Items.Count do
          if listbox3.Items.Strings[i-1]=nick+' ('+FromIP+')' then
          begin
            logged:=true;
            break;
          end
          else
            logged:=false;    //s ha az emberke nincs bent,
        if logged=false then
        begin                 //hozzadjuk a listhoz
          listbox3.Items.add(nick+' ('+FromIP+')');
                              //majd naplzunk
          memo3.Lines.Add('A rendszerben: '+nick+' ('+FromIP+')');
        end;
      end;
    end
    else
    if comm='logout' then    //ha logout-ot kapunk
    begin                    //akkor megkeressk embernket,
      for i:=1 to listbox3.Items.Count do
        if listbox3.Items.Strings[i-1]=nick+' ('+FromIP+')' then
        begin                //s trljk a listbl
          listbox3.Items.Delete(i-1);
                             //ismt napl
          memo3.Lines.Add('Kilpett: '+nick+' ('+FromIP+')');
        end;
    end
    else
    if comm='msg' then       //ha msg-t kapunk,
    begin                    //akkor berjuk a kldt s az zenetet az rkezett
                             //listba
      memo2.Lines.Add('<'+nick+'>'+msg+' (from '+fromip+')');
      kuldd(fromip, edit2.Text, '#ok#'); //s visszakldjk az "ok" parancsot,
                                         //jelezvn: az zenet megrkezett!
      label7.Visible:=true;
      label7.Caption:=nick+' ('+FromIp+')'; //kirjuk kitl kaptuk az utols zenetet
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  memo1.Clear;      //trlhetjuk a "kldtt" listt
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 memo2.Clear;       //trlhetjk az "rkezett" listt
end;

procedure TForm1.Button5Click(Sender: TObject); //lenyl men
begin
  if form1.Height=magassag then //ha egyenl a konstans magassggal
  begin
    button5.Caption:='<<';      //lenyitjuk 50 pixellel
    form1.Height:=form1.Height+50
  end
  else
  begin
    button5.Caption:='>>';      //klnben visszacsukjuk
    form1.Height:=form1.Height-50;
    selfname:=edit4.Text;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject); //szonr
var
  i : integer;            //ciklusvltoz
begin
  sonar:='';              //kezdrtk
  selfname:=edit4.Text;
  listbox3.Items.Clear;   //trljk csevegpartnerek listjt,
  for i:=1 to length(edit5.Text)-3 do //s a sajt IP cmnkhz ("mindenki" elejhez)
    sonar:=sonar+edit5.Text[i];
  sonar:=sonar+'255';     //hozzragasztjuk a 255-t.
  listbox3.Items.Add('Mindenki ('+sonar+')');  //hozzadjuk a listhoz a "mindenkit"
  kuldd(sonar, edit2.Text, '#login#'); //s kikldjk a szonr jelet (login)
  memo3.Lines.Add('Lista frisstse...')  //napl
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var                        //kilps
  i : integer;             //ciklusvltoz
begin
  sonar:='';
  for i:=1 to length(edit5.Text)-3 do //szonrhoz hasonl jel kldse
    sonar:=sonar+edit5.Text[i];
  sonar:=sonar+'255';
  memo3.Lines.Add('Elkszns a tbbiektl...');
  kuldd(sonar, edit2.Text, '#logout#'); //csak nem login, hanem logout
end;



procedure TForm1.udpInvalidHost(var handled: Boolean);
begin
  showmessage('Invalid HOST!');
end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then  //ha edit3-ban entert nyomunk, button1click hvdik meg
    button1.Click;
end;

procedure TForm1.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    button1.Click;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i : byte;
  WSAData: TWSAData;
  HostName: array[0..255] of Char;
  HostInfo: PHostEnt;
  InAddr: ^PInAddr;
begin
  memo3.Lines.Add('zenetkld indtsa...'); //napl+kezd rtkadsok
  sonar:='';
  form1.Height:=mag;
  magassag:=mag;
  if WSAStartup($0101, WSAData) = 0 then  //API hvs, hvd a help-et!
  try
    if gethostname(HostName, SizeOf(HostName)) = 0 then
    begin
      memo3.Lines.Add('Sajt nv lekrdezse...');
      HostInfo := gethostbyname(HostName);
      SelfName:=HostName;
      if HostInfo <> nil then  //ha HostInfo mutat valahova
      begin
        InAddr := Pointer(HostInfo^.h_addr_list); //a pointer ltal mutatott
        if (InAddr <> nil) then   //cm alatti rtk lesz a sajt IP cm
          while InAddr^ <> nil do //ez az sszes IP cm detektlsra j
          begin                   //(pl.: ha tbb hlkrtya van a gpben)
            memo3.Lines.Add('Sajt IP lekrdezse...');
            edit5.Text:=(inet_ntoa(InAddr^^));
            Inc(InAddr);
          end;
      end;
    end;
  finally              //vgl bezrjuk a WinSock-ot
    WSACleanup;        //nagyon fontos!
  end;                         //ez itt csak a dolgok cifrzsa,
  edit4.Text:=SelfName;        //s kezdeti rtkadsok
  edit4.Enabled:=false;
  edit5.Enabled:=false;
  udp.RemoteHost:=edit1.Text;
  udp.RemotePort:=strtoint(edit2.Text);
  udp.LocalPort:=udp.RemotePort;      //1 porton megy a kommunikci
  for i:=1 to length(edit5.Text)-3 do  //majd az els bejelentkezs
    sonar:=sonar+edit5.Text[i];
  sonar:=sonar+'255';
  memo3.Lines.Add('Bejelentkezs...'); //vadul runk a naplba
  kuldd(sonar, edit2.Text, '#login#');
  memo3.Lines.Add('''Mindenki'' hozzadsa...');
  listbox3.Items.Add('Mindenki ('+sonar+')');
  memo3.Lines.Add('Trsak keresse...');
  timer1.Enabled:=false;
end;

procedure TForm1.Memo3Change(Sender: TObject);
begin
  timer2.Enabled:=true;
end;

procedure TForm1.Timer2Timer(Sender: TObject); //a msodik timer a villogshoz kell
begin
  if label12.Font.Color=clred then
    label12.font.Color:=clblack
  else           //a napl felirat sznt feketre s pirosra vltjuk
    label12.font.Color:=clred;
  inc(villog);
  if villog=6 then  //ha hatszor villogott kikapcsoljuk a timer2-t
  begin
    villog:=0;
    timer2.Enabled:=false;
  end;
end;

procedure TForm1.ListBox3KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    button1.Click;
end;

end.
