unit MainFormServer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp;

type
  TForm1 = class(TForm)
    ServerSocket1: TServerSocket;
    MemoFogadas: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    EditValasz: TEdit;
    procedure FormShow(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
   ServerSocket1.Active := true;
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   MemoFogadas.Lines.Add( Socket.RemoteAddress +
      ' j kapcsolat');
         Socket.SendText('A kapcsolat ltrejtt!');

end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   MemoFogadas.Lines.Add( Socket.RemoteAddress +
      ' Bye-bye');
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
   MemoFogadas.Lines.Add( Socket.ReceiveText );
   Socket.SendText(EditValasz.Text);
end;

end.
